//****************************************************************************
//Name: ConvM3UFile.cpp
//
//Description: Takes an .m3u playlist and creates an .plp playlist that can
//             be read on a Samsung mp3 player.
//					
//****************************************************************************

#include "stdafx.h"
#include <stdio.h>
#include <fstream.h>
#include <iostream.h>
#include <string.h>

//uncomment if you want to set a default path
//#define DEBUG

#ifdef DEBUG
//****************************************************************************
//this needs to be changed to the user's playlist directory
#define PLAYLIST_PATH "D:\\share\\MP3\\playlist\\" 
//****************************************************************************
#endif

#define PLP_HDR_LINE1 "PLP PLAYLIST" 
#define PLP_HDR_LINE2 "VERSION 1.20" 
#define PLP_PATH "HDD, System\\Music\\" //path on mp3 player
#define HEADER_FILE "header.plp"
#define M3U_EXT ".m3u"
#define PLP_EXT ".plp"
#define CARRIAGE_RETURN 0xD
#define NEW_LINE 0xA
#define NULL 0
#define PLP_HEADER_SIZE 60
#define BUFF_SIZE 256

char * pathM3UFile = new char[BUFF_SIZE];
char * pathPLPFile = new char[BUFF_SIZE];

int main(int argc, char* argv[])
{
   char fileLine[BUFF_SIZE];
	char * M3UFileName = new char[BUFF_SIZE];
   char * ptrBegin = new char[BUFF_SIZE];
   char * ptrfileLine = new char[BUFF_SIZE];
   char * ptrPLPPathData = new char[BUFF_SIZE];
	char * header = new char[BUFF_SIZE];
   char carriageReturn = CARRIAGE_RETURN;
   char newLine = NEW_LINE;
   char null = NULL;
   unsigned int i=0; 

   //clear it out
   for(i=0; i<BUFF_SIZE; i++){
      fileLine[i] = 0;
      pathM3UFile[i] = 0;
      pathPLPFile[i] = 0;
   }
   
	printf("Please enter the path of the playlist directory\n");
	printf("The path must have a \\ at the end, ie D:\\Playlist\\ \n");
	cin>>pathPLPFile;
	printf("Please enter m3u file name(don't include extension) \n");
	cin>>M3UFileName;

	//generate file names
#ifdef DEBUG
 	strcat(pathPLPFile,PLAYLIST_PATH);
#else
 	strcat(pathM3UFile,pathPLPFile);
#endif
	strcat(pathPLPFile,M3UFileName);
	strcat(pathPLPFile,PLP_EXT);
#ifdef DEBUG
   strcat(pathM3UFile,PLAYLIST_PATH);
#endif
	strcat(M3UFileName, M3U_EXT);
	strcat(pathM3UFile, M3UFileName);
	//open a file stream
	ifstream inFile(pathM3UFile, ios::in);
	ofstream outFile (pathPLPFile, ios::binary);

   //verify the file is opened
   if (! inFile.is_open())
      throw "inFile could not be opened\n";
   //verify the file is opened
   if (! outFile.is_open())
      throw "outFile could not be opened\n";

   header = PLP_HDR_LINE1;
   for(i=0; i<strlen(header); i++)
   {
	  	outFile.put(header[i]);
		outFile.put(null);
   }
	outFile.put(carriageReturn);
	outFile.put(null);
	outFile.put(newLine);
	outFile.put(null);
   header = PLP_HDR_LINE2;
   for(i=0; i<strlen(header); i++)
   {
	  	outFile.put(header[i]);
		outFile.put(null);
   }
	outFile.put(carriageReturn);
	outFile.put(null);
	outFile.put(newLine);
	outFile.put(null);
	outFile.put(carriageReturn);
	outFile.put(null);
	outFile.put(newLine);
	outFile.put(null);
   
   //now let's go through this bad boy and pull out what we want
   while(!inFile.eof())
   {
		//read a line
   	inFile.getline(fileLine, BUFF_SIZE);
   	
   	//what kind of line is it?
	   if(fileLine[0] != '#')
	   {
			//no trash please, this is the reason I cleared it out below
			if(fileLine[0]==0)
				continue;
			else //valid line
			{      
				ptrfileLine = strtok(fileLine,"\\");
	      	while(ptrfileLine != NULL)
	      	{
		      	//set pointer to beginning
		      	ptrBegin = ptrfileLine;
		      	ptrfileLine = strtok(NULL,"\\");
	      	}
	      	//write out the path on the mp3 player
	      	ptrPLPPathData = PLP_PATH;
	      	for(i=0; i<strlen(ptrPLPPathData); i++)
	      	{
	      	outFile.put(ptrPLPPathData[i]);
   			outFile.put(null);
	      	}
	      	//write out the filename
	      	for(i=0; i<strlen(ptrBegin); i++)
	      	{
	      	outFile.put(ptrBegin[i]);
   			outFile.put(null);
	      	}
   			outFile.put(carriageReturn);
   			outFile.put(null);
   			outFile.put(carriageReturn);
   			outFile.put(null);
   			outFile.put(newLine);
   			outFile.put(null);
	
	      	//clear out buffer
	      	for(i=0; i<BUFF_SIZE; i++)
	      	   fileLine[i] = 0;
			}//end else good data
		}//end if !=#
	   else
	   {
		   //do nothing b/c we don't care about # lines
	   }
   }//end while

   inFile.close();
   outFile.close();
   return 0;
}

